(*                                                                      *)
(* MLJVM - a Java Virtual Machine implemented in Standard ML            *)
(*                                                                      *)
(* http://homepages.inf.ed.ac.uk/stg/research/projects/MLJVM/           *)
(*                                                                      *)
(* Copyright (C) 2003 Stephen Gilmore and Laura Korte, The              *)
(* University of Edinburgh.                                             *)
(*                                                                      *)
(* This program is free software; you can redistribute it and/or        *)
(* modify it under the terms of the GNU General Public License          *)
(* as published by the Free Software Foundation; either version 2       *)
(* of the License, or (at your option) any later version.               *)
(*                                                                      *)
(* This program is distributed in the hope that it will be useful,      *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of       *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *)
(* GNU General Public License for more details.                         *)
(*                                                                      *)
(* You should have received a copy of the GNU General Public License    *)
(* along with this program; if not, write to the Free Software          *)
(* Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *)
(* MA 02111-1307, USA.                                                  *)
(*                                                                      *)

local
   val home = "c:\\vakken eu\\project\\presentation"   
   val toolkit = home ^ "\\sml-jvm-toolkit"
   val _ = loadPath := toolkit::(!loadPath)
   val _ = loadPath := home::(!loadPath)
   
   fun myCompile dir file =
       (print ("Compiling " ^ file ^ "...\n") ; compile (dir ^ "\\" ^ file))
   
   val _ = myCompile home "Modifiers.sml"
   
   val _ = myCompile toolkit "Word16.sig"
   val _ = myCompile toolkit "Word16.sml"
   val _ = myCompile toolkit "Word32.sig"
   val _ = myCompile toolkit "Word32.sml"
   val _ = myCompile toolkit "Word64.sig"
   val _ = myCompile toolkit "Word64.sml"
   val _ = myCompile toolkit "Int32.sig"
   val _ = myCompile toolkit "Int32.sml"
   val _ = myCompile toolkit "Int64.sig"
   val _ = myCompile toolkit "Int64.sml"
   val _ = myCompile toolkit "Real32.sig"
   val _ = myCompile toolkit "Real32.sml"
   val _ = myCompile toolkit "Real64.sig"
   val _ = myCompile toolkit "Real64.sml"
   val _ = myCompile toolkit "Label.sig"
   val _ = myCompile toolkit "Label.sml"
   val _ = myCompile toolkit "Localvar.sig"
   val _ = myCompile toolkit "Localvar.sml"
   val _ = myCompile toolkit "Jvmtype.sig"
   val _ = myCompile toolkit "Jvmtype.sml"
   val _ = myCompile toolkit "ByteCode.sml"
   val _ = myCompile toolkit "Constpool.sig"
   val _ = myCompile toolkit "Constpool.sml"
   val _ = myCompile toolkit "Classdecl.sml"
   val _ = myCompile toolkit "Classfile.sig"
   val _ = myCompile toolkit "Classfile.sml"

   val _ = myCompile home "Error.sml"
   val _ = myCompile home "ByteCode2.sml"
   val _ = myCompile home "Runtimepool.sml"
   val _ = myCompile home "MyClassFile.sig"
   val _ = myCompile home "MyClassFile.sml"
   val _ = myCompile home "Parser.sig"
   val _ = myCompile home "Parser.sml"
   val _ = myCompile home "RuntimeClass.sml"
   val _ = myCompile home "JasminPrint.sig"
   val _ = myCompile home "JasminPrint.sml"
   val _ = myCompile home "Transform.sig"
   val _ = myCompile home "Transform.sml"
   val _ = myCompile home "Heap.sml"
   val _ = myCompile home "Environment.sml"
   val _ = myCompile home "Execute.sig"
   val _ = myCompile home "Execute.sml"

   val _ = print "\nCreating MLJVM.sml ...\n"

   val examples = home ^ "\\Examples"   
   
   fun doubleSlash #"\\" = "\\\\"
     | doubleSlash    c = str c
   val toolkitString  = String.translate doubleSlash toolkit
   val homeString     = String.translate doubleSlash home
   val examplesString = String.translate doubleSlash examples

   val filestring = 
       "loadPath := \"" ^ examplesString ^ "\"::(!loadPath);\n" ^
       "loadPath := \"" ^ toolkitString ^ "\"::(!loadPath);\n" ^
       "loadPath := \"" ^ homeString    ^ "\"::(!loadPath);\n" ^
       "load \"FileSys\";\n" ^
       "load \"" ^ homeString ^ "\\\\Execute\";\n" ^
       "load \"" ^ homeString ^ "\\\\Execute\";\n" ^
       "load \"" ^ homeString ^ "\\\\Parser\";\n" ^
       "load \"" ^ homeString ^ "\\\\JasminPrint\";\n"
   val outstream = TextIO.openOut (home ^ "\\" ^ "MLJVM.sml")
   val _ = TextIO.output (outstream,filestring)
   val _ = TextIO.closeOut outstream
   
   val _ = loadPath := examples::(!loadPath)
   
   val _ = load "FileSys"
   val _ = load "Execute"
   val _ = load "Parser"
   val _ = load "JasminPrint"
in
   val mljvm_compile = print "\nCompilation completed!\n\n"
end

