(*                                                                      *)
(* MLJVM - a Java Virtual Machine implemented in Standard ML            *)
(*                                                                      *)
(* http://homepages.inf.ed.ac.uk/stg/research/projects/MLJVM/           *)
(*                                                                      *)
(* Copyright (C) 2003 Stephen Gilmore and Laura Korte, The              *)
(* University of Edinburgh.                                             *)
(*                                                                      *)
(* This program is free software; you can redistribute it and/or        *)
(* modify it under the terms of the GNU General Public License          *)
(* as published by the Free Software Foundation; either version 2       *)
(* of the License, or (at your option) any later version.               *)
(*                                                                      *)
(* This program is distributed in the hope that it will be useful,      *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of       *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *)
(* GNU General Public License for more details.                         *)
(*                                                                      *)
(* You should have received a copy of the GNU General Public License    *)
(* along with this program; if not, write to the Free Software          *)
(* Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *)
(* MA 02111-1307, USA.                                                  *)
(*                                                                      *)

structure Error = 
struct

exception Error of string;
exception NoSuchMethodError of string;
exception NoSuchFieldError of string;
exception NoSuchClassError of string;
exception NoClassDefFoundError of string;

(*errors used for debugging the MLJVM*)
fun error file s = Error (s ^ " in " ^ file)
fun match_error file s = error file ("Match error occurred at *" ^ s ^ "*")
fun unimplemented_error file s = error file ("Unimplemented at *" ^ s ^ "*")
fun find_error file s = error file ("Polyhash.find at *" ^ s ^ "*")

(*MLJVM errors*)
fun noSuchMethodError c s = NoSuchMethodError (c ^ "." ^ s)
fun noSuchFieldError c s = NoSuchFieldError (c ^ "." ^ s)
fun noSuchClassError s = NoSuchClassError s
fun noSuchClassError s = NoClassDefFoundError s

end
