signature MyClassFile =
sig

(*** START PB CODE ***)
type local_var_info =
    {start  : Word16.word,
     length : Word16.word,
     name   : Constpool.index,
     desc   : Constpool.index,
     index  : Word16.word}

type line_number_info =
    {start : Word16.word,
     line  : Word16.word}

type exn_hdl =
    {start : Word16.word,
     stop  : Word16.word,
     entry : Word16.word,
     catch : Constpool.index option}

(* LK 20030531 - added inner_class_info *)
type inner_class_info =
    {inner_info  : Constpool.index option,
     outer_info  : Constpool.index option,
     inner_name  : Constpool.index option,
     inner_flags : Word16.word} 

datatype attribute =
    SRCFILE of {attr : Constpool.index,
		file : Constpool.index}
  | CONSTVAL of {attr  : Constpool.index,
		 value : Constpool.index}
  | CODE of {attr   : Constpool.index,
	     stack  : Word16.word,
	     locals : Word16.word,
	     code   : Word8Vector.vector,
	     hdls   : exn_hdl list,
	     attrs  : attribute list}
  | EXNS of {attr : Constpool.index,
	     exns : Constpool.index list}
  | LINENUM of {attr  : Constpool.index,
		lines : line_number_info list}
  | LOCALVAR of {attr : Constpool.index,
		 vars : local_var_info list}
  | INNER of {attr    : Constpool.index,				(* LK 20030531 - added INNER *)
              classes : inner_class_info list}
  | ATTR of {attr : Constpool.index,
	     info : Word8Vector.vector}

type member =
    {flags : Word16.word,
     name  : Constpool.index,
     desc  : Constpool.index,
     attrs : attribute list}

type class_file =
    {magic   : Word32.word,
     minor   : Word16.word,
     major   : Word16.word,
     pool    : Constpool.pool,
     flags   : Word16.word,
     this    : Constpool.index,
     super   : Constpool.index option,
     ifcs    : Constpool.index list,
     fields  : member list,
     methods : member list,
     attrs   : attribute list}

(**** END PB CODE ****)

val byte2string : Word8.word -> string
val my_map : (Word8.word -> string) -> Word8Vector.vector -> string
end
