(* Classfile.sig
 *
 * Peter Bertelsen
 * October 1997
 *)

exception InvalidClass of string

eqtype index
eqtype exn_hdl
eqtype line_number_info
eqtype local_var_info
eqtype inner_class_info
eqtype member
type class_file

datatype attribute =
    SRCFILE of {attr : index,
		file : index}
  | CONSTVAL of {attr  : index,
		 value : index}
  | CODE of {attr   : index,
	     stack  : Word16.word,
	     locals : Word16.word,
	     code   : Word8Vector.vector,
	     hdls   : exn_hdl list,
	     attrs  : attribute list}
  | EXNS of {attr : index,
	     exns : index list}
  | LINENUM of {attr  : index,
		lines : line_number_info list}
  | LOCALVAR of {attr : index,
		 vars : local_var_info list}
  | INNER of {attr    : index,		(* LK 20030531 - added INNER *)
              classes : inner_class_info list}
  | ATTR of {attr : index,
	     info : Word8Vector.vector}


(*val emit : (Word8.word -> unit) ->
           Constpool.pool -> Classdecl.class_decl ->  unit

val scan : (unit -> Word8.word) -> Classdecl.class_decl * Constpool.pool*)
